#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "leafnode.h"

#define SECONDS_PER_DAY ( 24*60*60 )

time_t now;

int debug = 0;

int age( const char * date );

int age( const char * date ) {
    char monthname[4];
    int month;
    int year;
    int day;
    const char * d;
    time_t tmp;
    struct tm time_struct;

    if ( !date )
	return 1000; /* large number: OLD */
    d = date;
    d += 5; /* "Date:" */
    while( isspace( *d ) )
	d++;

    if ( isalpha( d[0] ) && isalpha( d[1] ) && isalpha( d[2] ) && 
	 d[3] == ',' && isspace( d[4] ) )
	d += 5; /* skip Mon, */

    /* parsing with sscanf leads to crashes */
    day = strtol( d, NULL, 10 );
    while ( isdigit( *d ) )
	d++;
    while ( isspace( *d ) )
	d++;
    if ( !isalpha( *d ) )
	return 1003;
    monthname[0] = *d++;
    monthname[1] = *d++;
    monthname[2] = *d++;
    monthname[3] = '\0';
    if ( !isspace( *d ) )
	return 1005;
    while ( isspace( *d ) )
	d++;
    year = strtol( d, NULL, 10 );

    if ( ( year < 1995 ) && ( year > 100 ) )
	return 1004;
    else if ( !(day > 0 && day < 32) )
	return 1006;
    else {
	if ( year < 95 )
	    year += 100;	/* Y2K problem */
	if ( !strcasecmp( monthname, "jan" ) )
	    month = 0;
	else if ( !strcasecmp( monthname, "feb" ) )
	    month = 1;
	else if ( !strcasecmp( monthname, "mar" ) )
	    month = 2;
	else if ( !strcasecmp( monthname, "apr" ) )
	    month = 3;
	else if ( !strcasecmp( monthname, "may" ) )
	    month = 4;
	else if ( !strcasecmp( monthname, "jun" ) )
	    month = 5;
	else if ( !strcasecmp( monthname, "jul" ) )
	    month = 6;
	else if ( !strcasecmp( monthname, "aug" ) )
	    month = 7;
	else if ( !strcasecmp( monthname, "sep" ) )
	    month = 8;
	else if ( !strcasecmp( monthname, "oct" ) )
	    month = 9;
	else if ( !strcasecmp( monthname, "nov" ) )
	    month = 10;
	else if ( !strcasecmp( monthname, "dec" ) )
	    month = 11;
	else {
	    return 1001;
	}
	if ( year > 100 )
	    year -= 1900; /* *sigh */

        time_struct.tm_sec = 0;
	time_struct.tm_min = 0;
	time_struct.tm_hour = 0;
	time_struct.tm_mday = day;
	time_struct.tm_mon = month;
	time_struct.tm_year = year;
	time_struct.tm_isdst = 0;

	tmp = mktime( &time_struct );

	if ( tmp == -1 )
	    return 1002;
	
	return( ( now - tmp ) / SECONDS_PER_DAY );
    }
}		       

void main( int argc, char ** argv[] ) {
    int i, len;
    char *l, *p, *q;
    FILE *f;

    if ( argc != 2 ) {
	printf("Usage: %s datefile\n", argv[0] );
	exit(0);
    }

    f = fopen( argv[1], "r" );
    if ( !f ) {
	printf( "Unable to open %s\n", argv[1] );
	exit(0);
    }
    now = time(NULL);

    while ( ( l = getaline( f ) ) != NULL ) {
	len = age( l );
	if ( len > 100 )
	    printf("%d %s\n", age( l ), l );
    }
    fclose( f );
}
